#include <iostream>

using namespace std;

long long suma(int a[],int n){
    long long s=0;
    for(int i=0;i<n;i++)
        s+=a[i];
    return s;
}

long long f(int a[],int n,int k){
    if(k==0)
        return suma(a,n);
    else{
        long long s=0;
        for(int i=0;i<n;i++)
            for(int j=i;j<n;j++){
                s+=f(a+i,j-i+1,k-1);
                if(s>1000000007)
                    s=s%1000000007;
            }
        return s;
    }
}

int main()
{
    int n,k;
    cin>>n>>k;
    int a[n];
    for(int i=0;i<n;i++)
        cin>>a[i];
    cout<<f(a,n,k);
    return 0;
}